\chapter{Formal semantics}

\epigraph{Words are very unnecessary; they can only do harm.}{\cite{enjoy-the-silence}}

The core of the semantics of the Utena abstract machine is defined
using the Standard ML language \cite{sml}, in order to provide a precise
definition of the abstract machine. The core provides a sequential
subset of Utena, with only the primitives which affect control flow or
other parts of the abstract machine. We believe that using a formally
specified notation is necessary to avoid any ambiguities which plague
definitions written using less formal language (such as the infamous
Paxos Made Simple bug \cite{paxos}); we still provide commentary
on the machine in natural language, but such informal commentary
is non-normative and more likely to be misleading than the formal
semantics.

% I really shouldn't do ligature frobbery, but ASCII arrows look nasty
% with Inconsolata.
\lstset{
  language=ML,
  literate={>=}{$\ge$}2 {<=}{$\le$}2 {=>}{$\Rightarrow$}2 {->}{$\rightarrow$}2
}

\input{generated-semantics}